import { Component, Input } from '@angular/core';
import { Router, ActivatedRoute, NavigationEnd } from '@angular/router';
import 'rxjs/add/operator/filter';
// default
var ROUTE_DATA_PARAM = 'navTitle';
var NavTitle = (function () {
    function NavTitle() {
    }
    return NavTitle;
}());
export { NavTitle };
var NavTitleComponent = (function () {
    function NavTitleComponent(route, router) {
        this.route = route;
        this.router = router;
        this.separator = '–';
        this.dataParam = ROUTE_DATA_PARAM;
        this.titles = [];
    }
    NavTitleComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.titles = this.getNavTitles(this.route.snapshot);
        this.router.events
            .filter(function (event) { return event instanceof NavigationEnd; })
            .subscribe(function (event) { _this.titles = _this.getNavTitles(_this.route.snapshot); });
    };
    NavTitleComponent.prototype.getLastChildRoute = function (activatedSnapshot) {
        var children = activatedSnapshot.children;
        if (children.length === 0) {
            return activatedSnapshot;
        }
        return this.getLastChildRoute(children[0]);
    };
    // checks if the data.navTitle of the route is actually propagated from the parent route
    NavTitleComponent.prototype._isPropagatedData = function (childRoute, parentRoute) {
        return parentRoute && parentRoute.data[this.dataParam] === childRoute.data[this.dataParam];
    };
    NavTitleComponent.prototype.getNavTitles = function (activatedSnapshot) {
        var pathFromRoute = this.getLastChildRoute(activatedSnapshot).pathFromRoot;
        var titles = [];
        for (var _i = 0, pathFromRoute_1 = pathFromRoute; _i < pathFromRoute_1.length; _i++) {
            var route = pathFromRoute_1[_i];
            if (route.data.hasOwnProperty(this.dataParam)
                && typeof route.data[this.dataParam] === 'string'
                && !this._isPropagatedData(route, route.parent)) {
                titles.push({
                    label: route.data[this.dataParam],
                    url: route.pathFromRoot.filter(function (r) { return r.url.length > 0; }).map(function (r) { return r.url[0]; }).join('/')
                });
            }
        }
        return titles;
    };
    return NavTitleComponent;
}());
export { NavTitleComponent };
NavTitleComponent.decorators = [
    { type: Component, args: [{
                selector: 'nav-title',
                template: "<span *ngFor=\"let t of titles; let last = last;\">\n    <a routerLink=\"t.url\">{{t.label}}</a><span *ngIf=\"!last\"> {{separator}}</span>\n  </span>",
                styles: ['a{text-decoration:none;}']
            },] },
];
/** @nocollapse */
NavTitleComponent.ctorParameters = function () { return [
    { type: ActivatedRoute, },
    { type: Router, },
]; };
NavTitleComponent.propDecorators = {
    'separator': [{ type: Input },],
    'dataParam': [{ type: Input },],
};
//# sourceMappingURL=nav-title.component.js.map